package cat.itb.mateuyabar.dam.m03.uf6.projecte.data;


import cat.itb.mateuyabar.dam.m03.uf6.projecte.domain.Rectangle;

import java.sql.*;
import java.util.ArrayList;
import java.util.List;

public class RectangleDao {
    RectangleDatabase database;

    public RectangleDao(RectangleDatabase database) {
        this.database = database;
    }

    public Connection getConnection(){
        return database.getConnection();
    }

    public List<Rectangle> list() throws SQLException {
        String query = "SELECT * FROM rectangles";
        Statement listStatement = getConnection().createStatement();
        ResultSet resultat = listStatement.executeQuery(query);
        return toRectangleList(resultat);
    }

    private List<Rectangle> toRectangleList(ResultSet resultat) throws SQLException {
        List<Rectangle> list = new ArrayList<>();
        while (resultat.next()){
            int id = resultat.getInt("id");
            int width = resultat.getInt("width");
            int height = resultat.getInt("height");
            list.add(new Rectangle(id, width, height));
        }
        return list;
    }

    public void insert(Rectangle rectangle) throws SQLException {
        String query = "INSERT INTO rectangles(width, height) VALUES(?, ?)";
        PreparedStatement insertStatement = getConnection().prepareStatement(query);
        insertStatement.setInt(1, rectangle.getWidth());
        insertStatement.setInt(2, rectangle.getHeight());
        insertStatement.execute();
    }

    public List<Rectangle> listLagerThan(double area){
        // TODO: Access Database and obtain list of rectangles larger than area
        return null;
    }
}
